/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 812
#ifdef HAVE_CONFIG_H
#line 812
# include <config.h>
#line 812
#endif
#line 812
#include <sys/types.h>
#line 812

#line 812
#include "mailfromd.h"
#line 812
#include "prog.h"
#line 812
#include "builtin.h"
#line 812

#line 176 "io.bi"
static mu_debug_handle_t debug_handle;
#line 812 "io.bi"

#line 742 "../../src/builtin/snarf.m4"

#line 1 "io.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008, 2009, 2010, 2011 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include "global.h"

static size_t nstreams = MAX_IOSTREAMS;

static struct mu_cfg_param io_cfg_param[] = {
	{ "max-streams", mu_cfg_size, &nstreams, 0, NULL,
	  N_("Maximum number of stream descriptors.") },
	{ NULL }
};

struct io_stream {
	char *name;
	mu_locker_t lock;
	int fd[2];
	pid_t pid;
	char *buf;
	size_t bufsize;
	void (*cleanup)(void*);
	void *cleanup_data;
	char *delim;
};

#define IFD(s) ((s).fd[0])
#define OFD(s) ((s).fd[1] == -1 ? (s).fd[0] : (s).fd[1])

static void
flush_stream(struct io_stream *str)
{
	/*FIXME*/
}

static void
close_stream(struct io_stream *str)
{
	if (OFD(*str) == -1)
		return;
	flush_stream(str);
	close(OFD(*str));
	if (IFD(*str) != -1)
		close(IFD(*str));
	if (str->pid) {
		int status;
		waitpid(str->pid, &status, 0);
	}
	str->fd[0] = -1;
	str->fd[1] = -1;
	str->pid = 0;
	if (str->cleanup)
		str->cleanup(str->cleanup_data);
	str->cleanup = NULL;
	str->cleanup_data = NULL;
	if (str->name) {
		free(str->name);
		str->name = NULL;
	}
	if (str->delim) {
		free(str->delim);
		str->delim = NULL;
	}
}

/* Read bytes from the stream STR into its buffer, until
   DELIM is encountered. Return number of bytes read. */
static int
read_stream_delim(struct io_stream *str, char *delim)
{
	int fd = IFD(*str);
	size_t i = 0;
	int rc;
	size_t delim_len = strlen(delim);
	
	for (;;) {
		if (str->bufsize == i) {
			if (str->bufsize == 0) 
				str->bufsize = 16;
			str->buf = x2nrealloc(str->buf, &str->bufsize,
					      sizeof str->buf[1]);
		}
		rc = read(fd, str->buf + i, 1);
		if (rc == -1)
			return -1;
		else if (rc == 0)
			return 0;
		i++;
		if (i >= delim_len &&
		    memcmp(str->buf + i - delim_len, delim, delim_len) == 0) {
			str->buf[i - delim_len] = 0;
			break;
		}
	}
	return i;
}

#define REDIRECT_STDIN_P(f) ((f) & (O_WRONLY|O_RDWR))
#define REDIRECT_STDOUT_P(f) ((f) == O_RDONLY || ((f) & (O_RDONLY|O_RDWR)))

#define STDERR_SHUT        0
#define STDERR_NULL        1
#define STDERR_LOG         2
#define STDERR_FILE        3
#define STDERR_FILE_APPEND 4

#define LOG_TAG_PFX "mailfromd:"
#define LOG_TAG_PFX_LEN (sizeof(LOG_TAG_PFX)-1)

static void
stderr_to_log(char *arg, const char *cmd)
{
	int p[2];
	pid_t pid;
	
	if (pipe(p)) {
		mu_error(_("pipe failed: %s"), mu_strerror(errno));
		close(2);
		return;
	}

	pid = fork();

	if (pid == (pid_t) -1) {
		mu_error(_("fork failed: %s"), mu_strerror(errno));
		close(p[0]);
		close(p[1]);
		close(2);
		return;
	}
	
	/* Child */
	if (pid == 0) {
		FILE *fp;
		fd_set fdset;
		size_t len;
		char *buf = NULL;
		size_t bufsize = 0;
		char *tag;
		int fac = mu_log_facility, pri = LOG_ERR;
		
		if (arg) {
			char *p = strchr(arg, '.');

			if (p)
				*p++ = 0;
			if (mu_string_to_syslog_facility(arg, &fac)) {
				mu_error(_("unknown syslog facility (%s), "
					   "redirecting stderr to %s"),
					 arg,
					 mu_syslog_facility_to_string(fac));
			}
			
			if (p && mu_string_to_syslog_priority(p, &pri)) {
				mu_error(_("unknown syslog priority (%s), "
					   "redirecting stderr to %s"),
					 arg,
					 mu_syslog_priority_to_string(pri));
			}
		}
		
#line 176 "io.bi"

#line 176
mu_debug(debug_handle, 10,("redirecting stderr to syslog %s.%s",
		           mu_syslog_facility_to_string(fac),
		           mu_syslog_priority_to_string(pri)));
#line 180
		
		len = strcspn(cmd, " \t");
		tag = malloc(LOG_TAG_PFX_LEN + len + 1);
		if (!tag)
			tag = (char*) cmd;
		else {
			strcpy(tag, LOG_TAG_PFX);
			memcpy(tag + LOG_TAG_PFX_LEN, cmd, len);
			tag[LOG_TAG_PFX_LEN + len] = 0;
		}
		mf_proctitle_format("%s redirector", cmd);

		FD_ZERO(&fdset);
		FD_SET(p[0], &fdset);
		logger_fdset(&fdset);
		close_fds_except(&fdset);

		fp = fdopen(p[0], "r");
		logger_open();
		while (getline(&buf, &bufsize, fp) > 0)
			syslog(pri, "%s", buf);
		exit(0);
	}

	/* Parent */
	close(p[0]);
	dup2(p[1], 2);
	close(p[1]);
}
	
static void
stderr_handler(int mode, char *arg, const char *cmd)
{
	int fd;
	int append = O_TRUNC;
	
	switch (mode) {
	case STDERR_SHUT:
		close(2);
		break;

	case STDERR_NULL:
		arg = "/dev/null";
	case STDERR_FILE_APPEND:
		append = O_APPEND;
	case STDERR_FILE:
		if (!arg || !*arg) {
			close(2);
			break;
		}
		
#line 230

#line 230
mu_debug(debug_handle, 10,("redirecting stderr to %s", arg));
		fd = open(arg, O_CREAT|O_WRONLY|append, 0644);
		if (fd < 0) {
			mu_error(_("cannot open file %s for appending: %s"),
				 arg, mu_strerror(errno));
			close(2);
			return;
		}
		if (fd != 2) {
			dup2(fd, 2);
			close(fd);
		}
		break;

	case STDERR_LOG:
		stderr_to_log(arg, cmd);
	}
}

static void
parse_stderr_redirect(const char **pcmd, int *perr, char **parg)
{
	int err;
	size_t len;
	char *arg;
	const char *cmdline = *pcmd;
	
	while (*cmdline && c_isspace(*cmdline))
		cmdline++;
	if (strncmp(cmdline, "2>file:", 7) == 0) {
		cmdline += 7;
		err = STDERR_FILE;
	} else if (strncmp(cmdline, "2>>file:", 8) == 0) {
		cmdline += 8;
		err = STDERR_FILE_APPEND;
	} else if (strncmp(cmdline, "2>null:", 7) == 0) {
		cmdline += 7;
		err = STDERR_NULL;
	} else if (strncmp(cmdline, "2>syslog:", 9) == 0) {
		cmdline += 9;
		err = STDERR_LOG;
	} else
		return;

	len = strcspn(cmdline, " \t");
	if (len > 0 && cmdline[len-1] == 0)
		return;
	if (len == 0)
		arg = NULL;
	else {
		arg = malloc(len + 1);
		if (!arg)
			return;
		memcpy(arg, cmdline, len);
		arg[len] = 0;
	}

	*pcmd = cmdline + len;
	*perr = err;
	*parg = arg;
}


static int
open_program_stream(eval_environ_t env,
		    struct io_stream *str, const char *cmdline,
		    int flags)
{
	int rightp[2], leftp[2];
	int rc = 0;
	pid_t pid;
	int err = STDERR_SHUT;
	char *arg = NULL;
	struct mu_wordsplit ws;
	
	parse_stderr_redirect(&cmdline, &err, &arg);
	while (*cmdline && (*cmdline == ' ' || *cmdline == '\t'))
		cmdline++;
	
	if (REDIRECT_STDIN_P(flags))
		pipe(leftp);
	if (REDIRECT_STDOUT_P(flags))
		pipe(rightp);

	switch (pid = fork()) {
		/* The child branch.  */
	case 0:
		/* attach the pipes */

		/* Right-end */
		if (REDIRECT_STDOUT_P(flags)) {
			if (rightp[1] != 1) {
				close(1);
				dup2(rightp[1], 1);
			}
			close(rightp[0]);
		}

		/* Left-end */
		if (REDIRECT_STDIN_P(flags)) {
			if (leftp[0] != 0) {
				close(0);
				dup2(leftp[0], 0);
			}
			close(leftp[1]);
		}
      
		stderr_handler(err, arg, cmdline);
		
		/* Close unneded descripitors */
		close_fds_above(2);

		
#line 342

#line 342
mu_debug(debug_handle, 10,("running %s", cmdline));
		if (mu_wordsplit(cmdline, &ws, MU_WRDSF_DEFFLAGS)) {
			mu_error(_("cannot parse command line %s: %s"),
				 cmdline, mu_wordsplit_strerror(&ws));
			exit(127);
		}
		execvp(ws.ws_wordv[0], ws.ws_wordv);
		mu_error(_("cannot run %s: %s"),
			 cmdline, mu_strerror(rc));
		exit(127);
		/********************/

		/* Parent branches: */
	case -1:
		/* Fork has failed */
		/* Restore things */
		rc = errno;
		if (REDIRECT_STDOUT_P(flags)) {
			close(rightp[0]);
			close(rightp[1]);
		}
		if (REDIRECT_STDIN_P(flags)) {
			close(leftp[0]);
			close(leftp[1]);
		}
		break;
		
	default:
		str->pid = pid;
		if (REDIRECT_STDOUT_P(flags)) {
			str->fd[0] = rightp[0];
			close(rightp[1]);
		} else
			str->fd[0] = -1;

		if (REDIRECT_STDIN_P(flags)) {
			str->fd[1] = leftp[1];
			close(leftp[0]);
		} else
			str->fd[1] = -1;
	}
	free(arg);
	return rc;
}


static int
open_file_stream(eval_environ_t env,
		 struct io_stream *str, const char *file, int flags)
{
	str->fd[0] = open(file, flags, 0644); /* FIXME: mode? */
	if (str->fd[0] == -1)
		return errno;
	return 0;
}



static int
open_parsed_inet_stream(eval_environ_t env,
			struct io_stream *str,
			const char *cstr,
			char *proto, char *port, char *path,
			int flags)
{
	union {
		struct sockaddr sa;
		struct sockaddr_in s_in;
		struct sockaddr_un s_un;
#ifdef GACOPYZ_IPV6
		struct sockaddr_in6 s_in6;
#endif
	} addr;

	socklen_t socklen;
	int fd;
	int rc;

	if (!proto
	    || strcmp(proto, "unix") == 0 || strcmp(proto, "local") == 0) {
		struct stat st;
		
			if (!(port == NULL))
#line 424
		(
#line 424
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: %s; "
			    "port is meaningless for UNIX sockets"),cstr)
#line 424
)
#line 428
;
		
			if (!(strlen(path) <= sizeof addr.s_un.sun_path))
#line 430
		(
#line 430
	env_throw_bi(env, mfe_range, NULL, _("%s: UNIX socket name too long"),path)
#line 430
)
#line 433
;
		
		addr.sa.sa_family = PF_UNIX;
		socklen = sizeof(addr.s_un);
		strcpy(addr.s_un.sun_path, path);
		
		if (stat(path, &st)) {
			(
#line 440
	env_throw_bi(env, mfe_failure, NULL, _("%s: cannot stat socket: %s"),path,strerror(errno))
#line 440
);
#line 443
		} else {
			/* FIXME: Check permissions? */
				if (!(S_ISSOCK(st.st_mode)))
#line 445
		(
#line 445
	env_throw_bi(env, mfe_failure, NULL, _("%s: not a socket"),path)
#line 445
)
#line 448
;
		}

	} else if (strcmp(proto, "inet") == 0) {
		short pnum;
		long num;
		char *p;
		
		addr.sa.sa_family = PF_INET;
		socklen = sizeof(addr.s_in);

			if (!(port != NULL))
#line 459
		(
#line 459
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: %s; "
			    "missing port number"),cstr)
#line 459
)
#line 463
;

		num = pnum = strtol(port, &p, 0);
		if (*p == 0) {
				if (!(num == pnum))
#line 467
		(
#line 467
	env_throw_bi(env, mfe_range, NULL, _("invalid connection type: "
				    "%s; bad port number"),cstr)
#line 467
)
#line 471
;
			pnum = htons(pnum);
		} else {
			struct servent *sp = getservbyname(port, "tcp");

				if (!(sp != NULL))
#line 476
		(
#line 476
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: "
				    "%s; unknown port name"),cstr)
#line 476
)
#line 480
;
			pnum = sp->s_port;
		}
		
		if (!path)
			addr.s_in.sin_addr.s_addr = INADDR_ANY;
		else {
			struct hostent *hp = gethostbyname(path);
				if (!(hp != NULL))
#line 488
		(
#line 488
	env_throw_bi(env, mfe_failure, NULL, _("unknown host name %s"),path)
#line 488
)
#line 491
;
			addr.sa.sa_family = hp->h_addrtype;
			switch (hp->h_addrtype) {
			case AF_INET:
				memmove(&addr.s_in.sin_addr, hp->h_addr, 4);
				addr.s_in.sin_port = pnum;
				break;

			default:
				(
#line 500
	env_throw_bi(env, mfe_range, NULL, _("invalid connection type: "
					   "%s; unsupported address family"),cstr)
#line 500
);
#line 504
			}
		}
#ifdef GACOPYZ_IPV6
	} else if (strcmp(proto, "inet6") == 0) {
		struct addrinfo hints;
		struct addrinfo *res;
		
			if (!(port != NULL))
#line 511
		(
#line 511
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: %s; "
			    "missing port number"),cstr)
#line 511
)
#line 515
;

		memset(&hints, 0, sizeof(hints));
		hints.ai_family = AF_INET6;
		hints.ai_socktype = SOCK_STREAM;
		if (!path)
			hints.ai_flags |= AI_PASSIVE;
		
		rc = getaddrinfo(path, port, &hints, &res);
				
		switch (rc) {
		case 0:
			break;
			
		case EAI_SYSTEM:
			(
#line 530
	env_throw_bi(env, mfe_failure, NULL, _("%s:%s: cannot parse address: %s"),path,port,strerror(errno))
#line 530
);
#line 533
			
		case EAI_BADFLAGS:
		case EAI_SOCKTYPE:
			(
#line 536
	env_throw_bi(env, mfe_failure, NULL, _("%s:%d: internal error converting %s:%s"),__FILE__,__LINE__,path,port)
#line 536
);
#line 539
			
		case EAI_MEMORY:
			xalloc_die();
			
		default:
			(
#line 544
	env_throw_bi(env, mfe_failure, NULL, "%s:%s: %s",path,port,gai_strerror(rc))
#line 544
);
#line 547
		}

		socklen = res->ai_addrlen;
		if (socklen > sizeof(addr)) {
			freeaddrinfo(res);
			(
#line 552
	env_throw_bi(env, mfe_failure, NULL, _("%s:%s: address length too big (%lu)"),path,port,(unsigned long) socklen)
#line 552
);
#line 556
		}
		memcpy(&addr, res->ai_addr, res->ai_addrlen);
		freeaddrinfo(res);
#endif
	} else {
		(
#line 561
	env_throw_bi(env, mfe_range, NULL, _("unsupported protocol: %s"),proto)
#line 561
);
#line 564
	}

	fd = socket(addr.sa.sa_family, SOCK_STREAM, 0);
		if (!(fd != -1))
#line 567
		(
#line 567
	env_throw_bi(env, mfe_failure, NULL, _("unable to create new socket: %s"),strerror(errno))
#line 567
)
#line 570
;

	/* FIXME: Bind to the source ? */

	rc = connect(fd, &addr.sa, socklen);
	if (rc) {
		close(fd);
		(
#line 577
	env_throw_bi(env, mfe_failure, NULL, _("cannot connect to %s: %s"),cstr,strerror(errno))
#line 577
);
#line 580
	}
	
	str->fd[0] = fd;
	return 0;
}

static int
open_inet_stream(eval_environ_t env,
		 struct io_stream *str, const char *addr, int flags)
{
	int rc;
	char *proto, *port, *path;

	if (gacopyz_parse_connection(addr, &proto, &port, &path)
	    != MI_SUCCESS) 
		rc = ENOMEM; /* FIXME: or EINVAL? */
	else {
		rc = open_parsed_inet_stream(env,
					     str, addr,
					     proto, port, path, flags);
		free(proto);
		free(port);
		free(path);
	}
	return rc;
}


static void *
alloc_streams()
{
	struct io_stream *p, *stab = xcalloc(nstreams, sizeof *stab);
	for (p = stab; p < stab + nstreams; p++) 
		p->fd[0] = p->fd[1] = -1;
	return stab;
}

static void
destroy_streams(void *data)
{
	struct io_stream *stab = data;
	struct io_stream *p;
	for (p = stab; p < stab + nstreams; p++) {
		close_stream(p);
		free(p->buf);
	}
	free(stab);
}
		

#line 629

#line 629
static int IO_id;
#line 629 "io.bi"



void
#line 632
bi_open(eval_environ_t env)
#line 632

#line 632

#line 632 "io.bi"
{
#line 632
	
#line 632

#line 632

#line 632
char *  name;
#line 632
        
#line 632
get_string_arg(env, 0, &name);
#line 632
        
#line 632

#line 632
        adjust_stack(env, 1);
#line 632

#line 632

#line 632
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 632
		prog_trace(env, "open %s",name);;
#line 632

{
	int i, rc;
	int flags = 0;
	int (*opf)(eval_environ_t env,
		   struct io_stream *, const char *, int) = open_file_stream;
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	
	for (i = 0; i < nstreams; i++) {
		if (iotab[i].fd[0] == -1) 
			break;
	}
		if (!(i < nstreams))
#line 644
		(
#line 644
	env_throw_bi(env, mfe_failure, "open", _("no more files available"))
#line 644
)
#line 646
;

	
#line 648

#line 648
mu_debug(debug_handle, 10,("opening stream %s", name));
	iotab[i].name = xstrdup(name);
	iotab[i].delim = NULL;
	if (*name == '>') {
		flags |= O_RDWR|O_CREAT;
		name++;
		if (*name == '>') {
			flags |= O_APPEND;
			name++;
		} else
			flags |= O_TRUNC;
	} else if (*name == '|') {
		opf = open_program_stream;
		flags = O_WRONLY;
		name++;
		if (*name == '&') {
			flags = O_RDWR;
			name++;
		}
	} else if (*name == '@') {
		name++;
		opf = open_inet_stream;
		flags = O_RDWR;
	} else
		flags = O_RDONLY;
	
	for (;*name && c_isspace(*name); name++)
		;
	
	rc = opf(env, &iotab[i], name, flags);
	
		if (!(rc == 0))
#line 679
		(
#line 679
	env_throw_bi(env, mfe_failure, "open", _("cannot open stream %s: %s"),name,mu_strerror(rc))
#line 679
)
#line 682
;
	
#line 683

#line 683
mu_debug(debug_handle, 10,("open(%s) = %d", name, i));
	
#line 684
do {
#line 684
  push(env, (STKVAL) (i));
#line 684
  goto endlab;
#line 684
} while (0);
}
endlab:
#line 686
	return;
#line 686
}

void
#line 688
bi_close(eval_environ_t env)
#line 688

#line 688

#line 688 "io.bi"
{
#line 688
	
#line 688

#line 688

#line 688
long  fd;
#line 688
        
#line 688
get_numeric_arg(env, 0, &fd);
#line 688
        
#line 688

#line 688
        adjust_stack(env, 1);
#line 688

#line 688

#line 688
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 688
		prog_trace(env, "close %lu",fd);;
#line 688

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);

		if (!(fd >= 0 && fd < nstreams))
#line 692
		(
#line 692
	env_throw_bi(env, mfe_range, "close", _("invalid file descriptor"))
#line 692
)
#line 694
;
	close_stream(&iotab[fd]);
}

#line 697
	return;
#line 697
}	

void
#line 699
bi_write(eval_environ_t env)
#line 699

#line 699

#line 699 "io.bi"
{
#line 699
	
#line 699

#line 699
long __bi_argcnt;
#line 699
long  fd;
#line 699
        char *  str;
#line 699
        long  n;
#line 699
        
#line 699
get_numeric_arg(env, 1, &fd);
#line 699
        get_string_arg(env, 2, &str);
#line 699
        get_numeric_arg(env, 3, &n);
#line 699
        
#line 699
get_numeric_arg(env, 0, &__bi_argcnt);
#line 699
        adjust_stack(env, __bi_argcnt + 1);
#line 699

#line 699

#line 699
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 699
		prog_trace(env, "write %lu %s %lu",fd, str, ((__bi_argcnt > 2) ? n : 0));;
#line 699

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int rc;
	
	
#line 704

#line 704
mu_debug(debug_handle, 10,("writing %s to %lu", str, fd));
		if (!(fd >= 0 && fd < nstreams && OFD(iotab[fd]) != -1))
#line 705
		(
#line 705
	env_throw_bi(env, mfe_range, "write", _("invalid file descriptor"))
#line 705
)
#line 707
;
	if (!(__bi_argcnt > 2))
		n = strlen (str);
	rc = write(OFD(iotab[fd]), str, n);
		if (!(n == rc))
#line 711
		(
#line 711
	env_throw_bi(env, mfe_io, "write", _("write error on %s: %s"),iotab[fd].name,mu_strerror(errno))
#line 711
)
#line 714
;
}

#line 716
	return;
#line 716
}

void
#line 718
bi_read(eval_environ_t env)
#line 718

#line 718

#line 718 "io.bi"
{
#line 718
	
#line 718

#line 718

#line 718
long  fd;
#line 718
        long  size;
#line 718
        
#line 718
get_numeric_arg(env, 0, &fd);
#line 718
        get_numeric_arg(env, 1, &size);
#line 718
        
#line 718

#line 718
        adjust_stack(env, 2);
#line 718

#line 718

#line 718
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 718
		prog_trace(env, "read %lu %lu",fd, size);;
#line 718

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int rc;
	size_t off;
	char *s = (char*) env_data_ref(env, (off = heap_reserve(env, size + 1)));

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 725
		(
#line 725
	env_throw_bi(env, mfe_range, "read", _("invalid file descriptor"))
#line 725
)
#line 727
;
	
	rc = read(IFD(iotab[fd]), s, size);
	if (rc == 0)
		(
#line 731
	env_throw_bi(env, mfe_eof, "read", _("EOF on %s"),iotab[fd].name)
#line 731
);
#line 733
		if (!(rc == size))
#line 733
		(
#line 733
	env_throw_bi(env, mfe_io, "read", _("read error on %s: %s"),iotab[fd].name,mu_strerror(errno))
#line 733
)
#line 736
;
	s[size] = 0;
	
#line 738
do {
#line 738
  push(env, (STKVAL) (off));
#line 738
  goto endlab;
#line 738
} while (0);
}	
endlab:
#line 740
	return;
#line 740
}

void
#line 742
bi_getdelim(eval_environ_t env)
#line 742

#line 742

#line 742 "io.bi"
{
#line 742
	
#line 742

#line 742

#line 742
long  fd;
#line 742
        char * MFL_DATASEG delim;
#line 742
        
#line 742
get_numeric_arg(env, 0, &fd);
#line 742
        get_string_arg(env, 1, &delim);
#line 742
        
#line 742

#line 742
        adjust_stack(env, 2);
#line 742

#line 742

#line 742
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 742
		prog_trace(env, "getdelim %lu %s",fd, delim);;
#line 742

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;
	int rc;
	
		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 748
		(
#line 748
	env_throw_bi(env, mfe_range, "getdelim", _("invalid file descriptor"))
#line 748
)
#line 750
;
	ioptr = &iotab[fd];
	rc = read_stream_delim(ioptr, delim); 
	if (rc == 0)
		(
#line 754
	env_throw_bi(env, mfe_eof, "getdelim", _("EOF on %s"),ioptr->name)
#line 754
);
		if (!(rc > 0))
#line 755
		(
#line 755
	env_throw_bi(env, mfe_io, "getdelim", _("read error on %s: %s"),ioptr->name,mu_strerror(errno))
#line 755
)
#line 758
;
	do {pushs(env, ioptr->buf);
#line 759
goto endlab;
#line 759
} while (0);
}	
endlab:
#line 761
	return;
#line 761
}

void
#line 763
bi_getline(eval_environ_t env)
#line 763

#line 763

#line 763 "io.bi"
{
#line 763
	
#line 763

#line 763

#line 763
long  fd;
#line 763
        
#line 763
get_numeric_arg(env, 0, &fd);
#line 763
        
#line 763

#line 763
        adjust_stack(env, 1);
#line 763

#line 763

#line 763
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 763
		prog_trace(env, "getline %lu",fd);;
#line 763

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;
	int rc;

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 769
		(
#line 769
	env_throw_bi(env, mfe_range, "getline", _("invalid file descriptor"))
#line 769
)
#line 771
;
	ioptr = &iotab[fd];
	rc = read_stream_delim(ioptr, ioptr->delim ? ioptr->delim : "\n");
	if (rc == 0)
		(
#line 775
	env_throw_bi(env, mfe_eof, "getline", _("EOF on %s"),ioptr->name)
#line 775
);
#line 777
		if (!(rc > 0))
#line 777
		(
#line 777
	env_throw_bi(env, mfe_io, "getline", _("read error on %s: %s"),ioptr->name,mu_strerror(errno))
#line 777
)
#line 780
;
	do {pushs(env, ioptr->buf);
#line 781
goto endlab;
#line 781
} while (0);
}	
endlab:
#line 783
	return;
#line 783
}

void
#line 785
bi_fd_set_delimiter(eval_environ_t env)
#line 785

#line 785

#line 785 "io.bi"
{
#line 785
	
#line 785

#line 785

#line 785
long  fd;
#line 785
        char *  delim;
#line 785
        
#line 785
get_numeric_arg(env, 0, &fd);
#line 785
        get_string_arg(env, 1, &delim);
#line 785
        
#line 785

#line 785
        adjust_stack(env, 2);
#line 785

#line 785

#line 785
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 785
		prog_trace(env, "fd_set_delimiter %lu %s",fd, delim);;
#line 785

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 790
		(
#line 790
	env_throw_bi(env, mfe_range, "fd_set_delimiter", _("invalid file descriptor"))
#line 790
)
#line 792
;
	ioptr = &iotab[fd];
	free(ioptr->delim);
	ioptr->delim = xstrdup(delim);
}

#line 797
	return;
#line 797
}

void
#line 799
bi_fd_delimiter(eval_environ_t env)
#line 799

#line 799

#line 799 "io.bi"
{
#line 799
	
#line 799

#line 799

#line 799
long  fd;
#line 799
        char * MFL_DATASEG delim;
#line 799
        
#line 799
get_numeric_arg(env, 0, &fd);
#line 799
        get_string_arg(env, 1, &delim);
#line 799
        
#line 799

#line 799
        adjust_stack(env, 2);
#line 799

#line 799

#line 799
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 799
		prog_trace(env, "fd_delimiter %lu %s",fd, delim);;
#line 799

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 804
		(
#line 804
	env_throw_bi(env, mfe_range, "fd_delimiter", _("invalid file descriptor"))
#line 804
)
#line 806
;
	ioptr = &iotab[fd];
	do {pushs(env, ioptr->delim ? ioptr->delim : "\n");
#line 808
goto endlab;
#line 808
} while (0);
}
endlab:
#line 810
	return;
#line 810
}


#line 812
void
#line 812
io_init_builtin()
#line 812
{
#line 812
		debug_handle = mu_debug_register_category("bi_io");
#line 812

#line 812
	#line 629 "io.bi"
IO_id = builtin_priv_register(alloc_streams, destroy_streams,
#line 629
NULL);
#line 632 "io.bi"
va_builtin_install_ex("open", bi_open, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 688 "io.bi"
va_builtin_install_ex("close", bi_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 699 "io.bi"
va_builtin_install_ex("write", bi_write, 0, dtype_unspecified, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 718 "io.bi"
va_builtin_install_ex("read", bi_read, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 742 "io.bi"
va_builtin_install_ex("getdelim", bi_getdelim, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_string);
#line 763 "io.bi"
va_builtin_install_ex("getline", bi_getline, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 785 "io.bi"
va_builtin_install_ex("fd_set_delimiter", bi_fd_set_delimiter, 0, dtype_unspecified, 2, 0, 0|0, dtype_number, dtype_string);
#line 799 "io.bi"
va_builtin_install_ex("fd_delimiter", bi_fd_delimiter, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_string);

#line 812 "io.bi"
	
#line 812
	 mf_add_runtime_params(io_cfg_param);
#line 812
	 
#line 812
}
#line 812 "io.bi"

#line 814

#line 736 "../../src/builtin/snarf.m4"

#line 736

